!c Description:
!c  SSL2 ׻ΤΥѥå⥸塼
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Histry: 
!c   Version    Date          Comment
!c   -------    ----------    --------
!c   1.0        2004-04-28    
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2003, All rights reserved

module ssl2_linear
  implicit none
  
  private
  public ssl2_lax_init       !
  public ssl2_lax            !¹ϢΩ 1 ()
  public ssl2_lsx_init       !
  public ssl2_lsx            !¹ϢΩ 1 ()
  public ssl2_lsix_init      !
  public ssl2_lsix           !¹ϢΩ 1 ()

  real(8), allocatable      :: VW(:)  
  real(8)                   :: EPSZ = 0.0d0 ! ɸ
  integer, allocatable      :: IP(:)
  integer, allocatable      :: IVW(:)
  integer                   :: ISW = 1
  integer                   :: K = 10       !ͤϥߡ
  integer                   :: N = 10       !ͤϥߡ

  save K, N, ISW, IP, EPSZ, VW, IVW

contains

  subroutine ssl2_lax_init(M)
    integer, intent(in) :: M

    if (allocated(IP)) deallocate(IP, VW)
    allocate(IP(M), VW(M))
    N = M
    K = M
  end subroutine ssl2_lax_init
  

  subroutine ssl2_lax(A, B)
    real(8), intent(inout)         :: A(:,:)         !
    real(8), intent(inout)         :: B(:)           !/
    integer                        :: ICON
    integer                        :: IS

    IS = 0; VW = 0.0d0; IP = 0; ICON = 0

    !礭å
    if (N /= size(B,1) .OR. N /= size(A,1) .OR. N /= size(A,2)) then  
       write(*,*) "ssl2_lax; matrix size is wrong"
       stop
    end if

!    write(*,*) N, K, ISW
!    do IS = 1, N
!       write(*,*) A(IS,:)
!    end do
!    write(*,*) B

    !η׻. SSL II . 
    call DLAX(A, K, N, B, EPSZ, ISW, IS, VW, IP, ICON)
  
    !Υǥå. 
    if (ICON == 30000) then
       write(*,*) 'ssl2_lax: ICON is 30000' 
       stop
    elseif (ICON == 20000) then
       write(*,*) 'ssl2_lax: ICON is 20000' 
       write(*,*) "matrix is singular!"
       stop
    end if
  end subroutine ssl2_lax

    
  subroutine ssl2_lsx_init(M)
    integer, intent(in) :: M

    N = M
  end subroutine ssl2_lsx_init
  
  subroutine ssl2_lsx(A, B)
    real(8), intent(inout)         :: A(:)         !
    real(8), intent(inout)         :: B(:)           !/
    integer                        :: ICON

    ICON = 0

    !礭å
    if (N /= size(B,1) .OR. N*(N+1)/2 /= size(A,1)) then 
       write(*,*) "ssl2_lsx; matrix size is wrong"
    end if

    !η׻. SSL II . 
    call DLSX(A, N, B, EPSZ, ISW, ICON)
  
    !Υǥå. 
    if (ICON == 30000) then
       write(*,*) 'ssl2_lsx: ICON is 30000' 
       stop
    elseif (ICON == 20000) then
       write(*,*) 'ssl2_lsx: ICON is 20000' 
       write(*,*) "matrix is singular!"
       stop
    end if
  end subroutine ssl2_lsx
      
    
  subroutine ssl2_lsix_init(M)
    integer, intent(in) :: M

    if (allocated(IP)) deallocate(IP, VW, IVW)
    allocate(IP(M), VW(2*M), IVW(M))
    N = M
    K = M
  end subroutine ssl2_lsix_init


  subroutine ssl2_lsix(A, B)
    real(8), intent(inout)         :: A(:)         !
    real(8), intent(inout)         :: B(:)           !/
    integer                        :: ICON
    
    ICON = 0; VW = 0.0d0; IP = 0; IVW = 0

    !礭å
    if (N /= size(B,1) .OR. N*(N+1)/2 /= size(A,1)) then 
       write(*,*) "ssl2_lsx; matrix size is wrong"
    end if

    !η׻. SSL II . 
    call DLSIX(A, N, B, EPSZ, ISW, VW, IP, IVW, ICON)
  
    !Υǥå. 
    if (ICON == 30000) then
       write(*,*) 'ssl2_lsix: ICON is 30000' 
       stop
    elseif (ICON == 20000) then
       write(*,*) 'ssl2_lsix: ICON is 20000' 
       write(*,*) "matrix is singular!"
       stop
    end if
    
  end subroutine ssl2_lsix
  
    
end module ssl2_linear



